/*
 * Mattermost API Reference
 *
 * There is also a work-in-progress [Postman API reference](https://documenter.getpostman.com/view/4508214/RW8FERUn).
 *
 * The version of the OpenAPI document: 4.0.0
 * Contact: feedback@mattermost.com
 * Generated by: https://openapi-generator.tech
 */

use reqwest;

use super::{configuration, Error};
use super::ResponseContent;

/// struct for passing parameters to the method [`add_channels_to_retention_policy`]
#[derive(Clone, Debug, Default)]
pub struct AddChannelsToRetentionPolicyParams {
    /// The ID of the granular retention policy.
    pub policy_id: String,
    pub request_body: Vec<String>,
}

/// struct for passing parameters to the method [`add_teams_to_retention_policy`]
#[derive(Clone, Debug, Default)]
pub struct AddTeamsToRetentionPolicyParams {
    /// The ID of the granular retention policy.
    pub policy_id: String,
    pub request_body: Vec<String>,
}

/// struct for passing parameters to the method [`create_data_retention_policy`]
#[derive(Clone, Debug, Default)]
pub struct CreateDataRetentionPolicyParams {
    pub data_retention_policy_create: crate::openapi::models::DataRetentionPolicyCreate,
}

/// struct for passing parameters to the method [`delete_data_retention_policy`]
#[derive(Clone, Debug, Default)]
pub struct DeleteDataRetentionPolicyParams {
    /// The ID of the granular retention policy.
    pub policy_id: String,
}

/// struct for passing parameters to the method [`get_channel_policies_for_user`]
#[derive(Clone, Debug, Default)]
pub struct GetChannelPoliciesForUserParams {
    /// The ID of the user. This can also be \"me\" which will point to the current user.
    pub user_id: String,
    /// The page to select.
    pub page: Option<i32>,
    /// The number of policies per page. There is a maximum limit of 200 per page.
    pub per_page: Option<i32>,
}

/// struct for passing parameters to the method [`get_channels_for_retention_policy`]
#[derive(Clone, Debug, Default)]
pub struct GetChannelsForRetentionPolicyParams {
    /// The ID of the granular retention policy.
    pub policy_id: String,
    /// The page to select.
    pub page: Option<i32>,
    /// The number of channels per page. There is a maximum limit of 200 per page.
    pub per_page: Option<i32>,
}

/// struct for passing parameters to the method [`get_data_retention_policies`]
#[derive(Clone, Debug, Default)]
pub struct GetDataRetentionPoliciesParams {
    /// The page to select.
    pub page: Option<i32>,
    /// The number of policies per page. There is a maximum limit of 200 per page.
    pub per_page: Option<i32>,
}

/// struct for passing parameters to the method [`get_data_retention_policy_by_id`]
#[derive(Clone, Debug, Default)]
pub struct GetDataRetentionPolicyByIdParams {
    /// The ID of the granular retention policy.
    pub policy_id: String,
}

/// struct for passing parameters to the method [`get_team_policies_for_user`]
#[derive(Clone, Debug, Default)]
pub struct GetTeamPoliciesForUserParams {
    /// The ID of the user. This can also be \"me\" which will point to the current user.
    pub user_id: String,
    /// The page to select.
    pub page: Option<i32>,
    /// The number of policies per page. There is a maximum limit of 200 per page.
    pub per_page: Option<i32>,
}

/// struct for passing parameters to the method [`get_teams_for_retention_policy`]
#[derive(Clone, Debug, Default)]
pub struct GetTeamsForRetentionPolicyParams {
    /// The ID of the granular retention policy.
    pub policy_id: String,
    /// The page to select.
    pub page: Option<i32>,
    /// The number of teams per page. There is a maximum limit of 200 per page.
    pub per_page: Option<i32>,
}

/// struct for passing parameters to the method [`patch_data_retention_policy`]
#[derive(Clone, Debug, Default)]
pub struct PatchDataRetentionPolicyParams {
    /// The ID of the granular retention policy.
    pub policy_id: String,
    pub data_retention_policy_with_team_and_channel_ids:
        crate::openapi::models::DataRetentionPolicyWithTeamAndChannelIds,
}

/// struct for passing parameters to the method [`remove_channels_from_retention_policy`]
#[derive(Clone, Debug, Default)]
pub struct RemoveChannelsFromRetentionPolicyParams {
    /// The ID of the granular retention policy.
    pub policy_id: String,
    pub request_body: Vec<String>,
}

/// struct for passing parameters to the method [`remove_teams_from_retention_policy`]
#[derive(Clone, Debug, Default)]
pub struct RemoveTeamsFromRetentionPolicyParams {
    /// The ID of the granular retention policy.
    pub policy_id: String,
    pub request_body: Vec<String>,
}

/// struct for passing parameters to the method [`search_channels_for_retention_policy`]
#[derive(Clone, Debug, Default)]
pub struct SearchChannelsForRetentionPolicyParams {
    /// The ID of the granular retention policy.
    pub policy_id: String,
    pub search_channels_for_retention_policy_request:
        crate::openapi::models::SearchChannelsForRetentionPolicyRequest,
}

/// struct for passing parameters to the method [`search_teams_for_retention_policy`]
#[derive(Clone, Debug, Default)]
pub struct SearchTeamsForRetentionPolicyParams {
    /// The ID of the granular retention policy.
    pub policy_id: String,
    pub search_teams_for_retention_policy_request:
        crate::openapi::models::SearchTeamsForRetentionPolicyRequest,
}

/// struct for typed errors of method [`add_channels_to_retention_policy`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum AddChannelsToRetentionPolicyError {
    Status401(crate::openapi::models::AppError),
    Status403(crate::openapi::models::AppError),
    Status500(crate::openapi::models::AppError),
    Status501(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`add_teams_to_retention_policy`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum AddTeamsToRetentionPolicyError {
    Status401(crate::openapi::models::AppError),
    Status403(crate::openapi::models::AppError),
    Status500(crate::openapi::models::AppError),
    Status501(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`create_data_retention_policy`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum CreateDataRetentionPolicyError {
    Status401(crate::openapi::models::AppError),
    Status403(crate::openapi::models::AppError),
    Status500(crate::openapi::models::AppError),
    Status501(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`delete_data_retention_policy`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum DeleteDataRetentionPolicyError {
    Status401(crate::openapi::models::AppError),
    Status403(crate::openapi::models::AppError),
    Status500(crate::openapi::models::AppError),
    Status501(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`get_channel_policies_for_user`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum GetChannelPoliciesForUserError {
    Status401(crate::openapi::models::AppError),
    Status403(crate::openapi::models::AppError),
    Status500(crate::openapi::models::AppError),
    Status501(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`get_channels_for_retention_policy`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum GetChannelsForRetentionPolicyError {
    Status401(crate::openapi::models::AppError),
    Status403(crate::openapi::models::AppError),
    Status500(crate::openapi::models::AppError),
    Status501(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`get_data_retention_policies`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum GetDataRetentionPoliciesError {
    Status401(crate::openapi::models::AppError),
    Status403(crate::openapi::models::AppError),
    Status500(crate::openapi::models::AppError),
    Status501(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`get_data_retention_policies_count`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum GetDataRetentionPoliciesCountError {
    Status401(crate::openapi::models::AppError),
    Status403(crate::openapi::models::AppError),
    Status500(crate::openapi::models::AppError),
    Status501(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`get_data_retention_policy`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum GetDataRetentionPolicyError {
    Status401(crate::openapi::models::AppError),
    Status403(crate::openapi::models::AppError),
    Status500(crate::openapi::models::AppError),
    Status501(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`get_data_retention_policy_by_id`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum GetDataRetentionPolicyByIdError {
    Status401(crate::openapi::models::AppError),
    Status403(crate::openapi::models::AppError),
    Status500(crate::openapi::models::AppError),
    Status501(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`get_team_policies_for_user`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum GetTeamPoliciesForUserError {
    Status401(crate::openapi::models::AppError),
    Status403(crate::openapi::models::AppError),
    Status500(crate::openapi::models::AppError),
    Status501(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`get_teams_for_retention_policy`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum GetTeamsForRetentionPolicyError {
    Status401(crate::openapi::models::AppError),
    Status403(crate::openapi::models::AppError),
    Status500(crate::openapi::models::AppError),
    Status501(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`patch_data_retention_policy`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum PatchDataRetentionPolicyError {
    Status401(crate::openapi::models::AppError),
    Status403(crate::openapi::models::AppError),
    Status500(crate::openapi::models::AppError),
    Status501(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`remove_channels_from_retention_policy`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum RemoveChannelsFromRetentionPolicyError {
    Status401(crate::openapi::models::AppError),
    Status403(crate::openapi::models::AppError),
    Status500(crate::openapi::models::AppError),
    Status501(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`remove_teams_from_retention_policy`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum RemoveTeamsFromRetentionPolicyError {
    Status401(crate::openapi::models::AppError),
    Status403(crate::openapi::models::AppError),
    Status500(crate::openapi::models::AppError),
    Status501(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`search_channels_for_retention_policy`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum SearchChannelsForRetentionPolicyError {
    Status401(crate::openapi::models::AppError),
    Status403(crate::openapi::models::AppError),
    Status500(crate::openapi::models::AppError),
    Status501(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`search_teams_for_retention_policy`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum SearchTeamsForRetentionPolicyError {
    Status401(crate::openapi::models::AppError),
    Status403(crate::openapi::models::AppError),
    Status500(crate::openapi::models::AppError),
    Status501(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// Adds channels to a granular data retention policy.   __Minimum server version__: 5.35  ##### Permissions Must have the `sysconsole_write_compliance_data_retention` permission.  ##### License Requires an E20 license.
pub async fn add_channels_to_retention_policy(
    configuration: &configuration::Configuration,
    params: AddChannelsToRetentionPolicyParams,
) -> Result<crate::openapi::models::StatusOk, Error<AddChannelsToRetentionPolicyError>> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let policy_id = params.policy_id;
    let request_body = params.request_body;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/data_retention/policies/{policy_id}/channels",
        local_var_configuration.base_path,
        policy_id = super::urlencode(policy_id)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::POST, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };
    local_var_req_builder = local_var_req_builder.json(&request_body);

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<AddChannelsToRetentionPolicyError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Adds teams to a granular data retention policy.   __Minimum server version__: 5.35  ##### Permissions Must have the `sysconsole_write_compliance_data_retention` permission.  ##### License Requires an E20 license.
pub async fn add_teams_to_retention_policy(
    configuration: &configuration::Configuration,
    params: AddTeamsToRetentionPolicyParams,
) -> Result<crate::openapi::models::StatusOk, Error<AddTeamsToRetentionPolicyError>> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let policy_id = params.policy_id;
    let request_body = params.request_body;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/data_retention/policies/{policy_id}/teams",
        local_var_configuration.base_path,
        policy_id = super::urlencode(policy_id)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::POST, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };
    local_var_req_builder = local_var_req_builder.json(&request_body);

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<AddTeamsToRetentionPolicyError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Creates a new granular data retention policy with the specified display name and post duration.  __Minimum server version__: 5.35  ##### Permissions Must have the `sysconsole_write_compliance_data_retention` permission.  ##### License Requires an E20 license.
pub async fn create_data_retention_policy(
    configuration: &configuration::Configuration,
    params: CreateDataRetentionPolicyParams,
) -> Result<
    crate::openapi::models::DataRetentionPolicyWithTeamAndChannelCounts,
    Error<CreateDataRetentionPolicyError>,
> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let data_retention_policy_create = params.data_retention_policy_create;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/data_retention/policies",
        local_var_configuration.base_path
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::POST, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };
    local_var_req_builder = local_var_req_builder.json(&data_retention_policy_create);

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<CreateDataRetentionPolicyError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Deletes a granular data retention policy.  __Minimum server version__: 5.35  ##### Permissions Must have the `sysconsole_write_compliance_data_retention` permission.  ##### License Requires an E20 license.
pub async fn delete_data_retention_policy(
    configuration: &configuration::Configuration,
    params: DeleteDataRetentionPolicyParams,
) -> Result<crate::openapi::models::StatusOk, Error<DeleteDataRetentionPolicyError>> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let policy_id = params.policy_id;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/data_retention/policies/{policy_id}",
        local_var_configuration.base_path,
        policy_id = super::urlencode(policy_id)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::DELETE, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<DeleteDataRetentionPolicyError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Gets the policies which are applied to the all of the channels to which a user belongs.  __Minimum server version__: 5.35  ##### Permissions Must be logged in as the user or have the `manage_system` permission.  ##### License Requires an E20 license.
pub async fn get_channel_policies_for_user(
    configuration: &configuration::Configuration,
    params: GetChannelPoliciesForUserParams,
) -> Result<crate::openapi::models::RetentionPolicyForChannelList, Error<GetChannelPoliciesForUserError>> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let user_id = params.user_id;
    let page = params.page;
    let per_page = params.per_page;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/users/{user_id}/data_retention/channel_policies",
        local_var_configuration.base_path,
        user_id = super::urlencode(user_id)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::GET, local_var_uri_str.as_str());

    if let Some(ref local_var_str) = page {
        local_var_req_builder =
            local_var_req_builder.query(&[("page", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = per_page {
        local_var_req_builder =
            local_var_req_builder.query(&[("per_page", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<GetChannelPoliciesForUserError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Gets the channels to which a granular data retention policy is applied.  __Minimum server version__: 5.35  ##### Permissions Must have the `sysconsole_read_compliance_data_retention` permission.  ##### License Requires an E20 license.
pub async fn get_channels_for_retention_policy(
    configuration: &configuration::Configuration,
    params: GetChannelsForRetentionPolicyParams,
) -> Result<Vec<crate::openapi::models::ChannelWithTeamData>, Error<GetChannelsForRetentionPolicyError>> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let policy_id = params.policy_id;
    let page = params.page;
    let per_page = params.per_page;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/data_retention/policies/{policy_id}/channels",
        local_var_configuration.base_path,
        policy_id = super::urlencode(policy_id)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::GET, local_var_uri_str.as_str());

    if let Some(ref local_var_str) = page {
        local_var_req_builder =
            local_var_req_builder.query(&[("page", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = per_page {
        local_var_req_builder =
            local_var_req_builder.query(&[("per_page", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<GetChannelsForRetentionPolicyError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Gets details about the granular (i.e. team or channel-specific) data retention policies from the server.  __Minimum server version__: 5.35  ##### Permissions Must have the `sysconsole_read_compliance_data_retention` permission.  ##### License Requires an E20 license.
pub async fn get_data_retention_policies(
    configuration: &configuration::Configuration,
    params: GetDataRetentionPoliciesParams,
) -> Result<
    Vec<crate::openapi::models::DataRetentionPolicyWithTeamAndChannelCounts>,
    Error<GetDataRetentionPoliciesError>,
> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let page = params.page;
    let per_page = params.per_page;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/data_retention/policies",
        local_var_configuration.base_path
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::GET, local_var_uri_str.as_str());

    if let Some(ref local_var_str) = page {
        local_var_req_builder =
            local_var_req_builder.query(&[("page", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = per_page {
        local_var_req_builder =
            local_var_req_builder.query(&[("per_page", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<GetDataRetentionPoliciesError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Gets the number of granular (i.e. team or channel-specific) data retention policies from the server.  __Minimum server version__: 5.35  ##### Permissions Must have the `sysconsole_read_compliance_data_retention` permission.  ##### License Requires an E20 license.
pub async fn get_data_retention_policies_count(
    configuration: &configuration::Configuration,
) -> Result<
    crate::openapi::models::GetDataRetentionPoliciesCount200Response,
    Error<GetDataRetentionPoliciesCountError>,
> {
    let local_var_configuration = configuration;

    // unbox the parameters

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/data_retention/policies_count",
        local_var_configuration.base_path
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::GET, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<GetDataRetentionPoliciesCountError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Gets the current global data retention policy details from the server, including what data should be purged and the cutoff times for each data type that should be purged.  __Minimum server version__: 4.3  ##### Permissions Requires an active session but no other permissions.  ##### License Requires an E20 license.
pub async fn get_data_retention_policy(
    configuration: &configuration::Configuration,
) -> Result<crate::openapi::models::GlobalDataRetentionPolicy, Error<GetDataRetentionPolicyError>> {
    let local_var_configuration = configuration;

    // unbox the parameters

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/data_retention/policy",
        local_var_configuration.base_path
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::GET, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<GetDataRetentionPolicyError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Gets details about a granular data retention policies by ID.  __Minimum server version__: 5.35  ##### Permissions Must have the `sysconsole_read_compliance_data_retention` permission.  ##### License Requires an E20 license.
pub async fn get_data_retention_policy_by_id(
    configuration: &configuration::Configuration,
    params: GetDataRetentionPolicyByIdParams,
) -> Result<
    crate::openapi::models::DataRetentionPolicyWithTeamAndChannelCounts,
    Error<GetDataRetentionPolicyByIdError>,
> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let policy_id = params.policy_id;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/data_retention/policies/{policy_id}",
        local_var_configuration.base_path,
        policy_id = super::urlencode(policy_id)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::GET, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<GetDataRetentionPolicyByIdError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Gets the policies which are applied to the all of the teams to which a user belongs.  __Minimum server version__: 5.35  ##### Permissions Must be logged in as the user or have the `manage_system` permission.  ##### License Requires an E20 license.
pub async fn get_team_policies_for_user(
    configuration: &configuration::Configuration,
    params: GetTeamPoliciesForUserParams,
) -> Result<crate::openapi::models::RetentionPolicyForTeamList, Error<GetTeamPoliciesForUserError>> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let user_id = params.user_id;
    let page = params.page;
    let per_page = params.per_page;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/users/{user_id}/data_retention/team_policies",
        local_var_configuration.base_path,
        user_id = super::urlencode(user_id)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::GET, local_var_uri_str.as_str());

    if let Some(ref local_var_str) = page {
        local_var_req_builder =
            local_var_req_builder.query(&[("page", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = per_page {
        local_var_req_builder =
            local_var_req_builder.query(&[("per_page", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<GetTeamPoliciesForUserError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Gets the teams to which a granular data retention policy is applied.  __Minimum server version__: 5.35  ##### Permissions Must have the `sysconsole_read_compliance_data_retention` permission.  ##### License Requires an E20 license.
pub async fn get_teams_for_retention_policy(
    configuration: &configuration::Configuration,
    params: GetTeamsForRetentionPolicyParams,
) -> Result<Vec<crate::openapi::models::Team>, Error<GetTeamsForRetentionPolicyError>> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let policy_id = params.policy_id;
    let page = params.page;
    let per_page = params.per_page;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/data_retention/policies/{policy_id}/teams",
        local_var_configuration.base_path,
        policy_id = super::urlencode(policy_id)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::GET, local_var_uri_str.as_str());

    if let Some(ref local_var_str) = page {
        local_var_req_builder =
            local_var_req_builder.query(&[("page", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = per_page {
        local_var_req_builder =
            local_var_req_builder.query(&[("per_page", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<GetTeamsForRetentionPolicyError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Patches (i.e. replaces the fields of) a granular data retention policy. If any fields are omitted, they will not be changed.  __Minimum server version__: 5.35  ##### Permissions Must have the `sysconsole_write_compliance_data_retention` permission.  ##### License Requires an E20 license.
pub async fn patch_data_retention_policy(
    configuration: &configuration::Configuration,
    params: PatchDataRetentionPolicyParams,
) -> Result<
    crate::openapi::models::DataRetentionPolicyWithTeamAndChannelCounts,
    Error<PatchDataRetentionPolicyError>,
> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let policy_id = params.policy_id;
    let data_retention_policy_with_team_and_channel_ids =
        params.data_retention_policy_with_team_and_channel_ids;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/data_retention/policies/{policy_id}",
        local_var_configuration.base_path,
        policy_id = super::urlencode(policy_id)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::PATCH, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };
    local_var_req_builder =
        local_var_req_builder.json(&data_retention_policy_with_team_and_channel_ids);

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<PatchDataRetentionPolicyError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Delete channels from a granular data retention policy.   __Minimum server version__: 5.35  ##### Permissions Must have the `sysconsole_write_compliance_data_retention` permission.  ##### License Requires an E20 license.
pub async fn remove_channels_from_retention_policy(
    configuration: &configuration::Configuration,
    params: RemoveChannelsFromRetentionPolicyParams,
) -> Result<crate::openapi::models::StatusOk, Error<RemoveChannelsFromRetentionPolicyError>> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let policy_id = params.policy_id;
    let request_body = params.request_body;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/data_retention/policies/{policy_id}/channels",
        local_var_configuration.base_path,
        policy_id = super::urlencode(policy_id)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::DELETE, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };
    local_var_req_builder = local_var_req_builder.json(&request_body);

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<RemoveChannelsFromRetentionPolicyError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Delete teams from a granular data retention policy.   __Minimum server version__: 5.35  ##### Permissions Must have the `sysconsole_write_compliance_data_retention` permission.  ##### License Requires an E20 license.
pub async fn remove_teams_from_retention_policy(
    configuration: &configuration::Configuration,
    params: RemoveTeamsFromRetentionPolicyParams,
) -> Result<crate::openapi::models::StatusOk, Error<RemoveTeamsFromRetentionPolicyError>> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let policy_id = params.policy_id;
    let request_body = params.request_body;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/data_retention/policies/{policy_id}/teams",
        local_var_configuration.base_path,
        policy_id = super::urlencode(policy_id)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::DELETE, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };
    local_var_req_builder = local_var_req_builder.json(&request_body);

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<RemoveTeamsFromRetentionPolicyError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Searches for the channels to which a granular data retention policy is applied.  __Minimum server version__: 5.35  ##### Permissions Must have the `sysconsole_read_compliance_data_retention` permission.  ##### License Requires an E20 license.
pub async fn search_channels_for_retention_policy(
    configuration: &configuration::Configuration,
    params: SearchChannelsForRetentionPolicyParams,
) -> Result<Vec<crate::openapi::models::ChannelWithTeamData>, Error<SearchChannelsForRetentionPolicyError>> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let policy_id = params.policy_id;
    let search_channels_for_retention_policy_request =
        params.search_channels_for_retention_policy_request;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/data_retention/policies/{policy_id}/channels/search",
        local_var_configuration.base_path,
        policy_id = super::urlencode(policy_id)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::POST, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };
    local_var_req_builder =
        local_var_req_builder.json(&search_channels_for_retention_policy_request);

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<SearchChannelsForRetentionPolicyError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Searches for the teams to which a granular data retention policy is applied.  __Minimum server version__: 5.35  ##### Permissions Must have the `sysconsole_read_compliance_data_retention` permission.  ##### License Requires an E20 license.
pub async fn search_teams_for_retention_policy(
    configuration: &configuration::Configuration,
    params: SearchTeamsForRetentionPolicyParams,
) -> Result<Vec<crate::openapi::models::Team>, Error<SearchTeamsForRetentionPolicyError>> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let policy_id = params.policy_id;
    let search_teams_for_retention_policy_request =
        params.search_teams_for_retention_policy_request;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/data_retention/policies/{policy_id}/teams/search",
        local_var_configuration.base_path,
        policy_id = super::urlencode(policy_id)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::POST, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };
    local_var_req_builder = local_var_req_builder.json(&search_teams_for_retention_policy_request);

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<SearchTeamsForRetentionPolicyError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}
